#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <stack>

using namespace std;

int to_index(char c) {
    if (c >= 'a' && c <= 'z')
        return c - 'a';
    if (c >= 'A' && c <= 'Z')
        return c - 'A' + 26;
    assert(false);
}

int main() {
    ifstream cin("anagrame.in");
    ofstream cout("anagrame.out");

    int type; assert(cin >> type);
    string S, P; assert(cin >> S >> P);

    assert(1 <= S.size() && S.size() <= 1000 * 1000);
    assert(1 <= P.size() && P.size() <= S.size());

    for (auto &c : S)
        assert(('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z'));
    for (auto &c : P)
        assert(('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z'));

    vector<int> need(52, 0);
    for (auto &c : P)
        ++need[to_index(c)];

    int total = P.size();

    vector<int> where;
    for (int i = S.size() - 1; i >= 0; --i) {
        if (need[to_index(S[i])] > 0) {
            --need[to_index(S[i])];
            if (--total == 0) {
                where.push_back(i);
                total = P.size();
                for (auto &c : P)
                    ++need[to_index(c)];
            }
        }
    }

    if (type == 1) {
        cout << where.size() << "\n";
        return 0;
    }

    reverse(where.begin(), where.end());
    where.push_back(S.size());
    where.erase(where.begin());

    int last = 0;
    for (auto &c : P)
        need[to_index(c)] = 0;

    vector<char> st;
    vector<int> have(52, 0);
    for (int i = 0; i < int(where.size()); ++i) {
        for (auto &c : P)
            have[to_index(c)] = need[to_index(c)] = 0;
        for (int j = last; j < where[i]; ++j)
            ++have[to_index(S[j])];
        for (auto &c : P)
            ++need[to_index(c)];

        st.clear();
        for (int j = last; j < where[i]; ++j) {
            if (!need[to_index(S[j])]) {
				--have[to_index(S[j])];
                continue;
            }

            // i need it, and its better
            while (!st.empty() && st.back() > S[j] && need[to_index(st.back())] < have[to_index(st.back())]) {
                need[to_index(st.back())]++;
                st.pop_back();
            }
			st.push_back(S[j]);

            need[to_index(st.back())]--;
            have[to_index(st.back())]--;
        }


        for (auto &c : st) {
            while (S[last] != c) {
                ++last;
            }
            ++last;
			cout << c;
        }
    }
	cout << "\n";
}
