#include <vector>
#include <string>
#include <fstream>
using namespace std;
struct cosmin2{

    int solve() {
        ifstream        f("anagrame.in");
        ofstream        g("anagrame.out");
        int             P;
        string          A, B; f >> P >> A >> B;
        vector<int>     len(A.size() + 1);
        vector<int>     freq(26);
        string          ans = "";

        // compute the frequencies for the second string
        for (char c : B) freq[c - 'a']++;

        // compute the maximum number of anagrams for any suffix of the first string
        // we are interested only in the right most anagrams
        auto crtFreq    = freq;
        auto crtLetters = B.size();
        len[A.size()]   = 0;
        for (int i = (int)A.size() - 1; i >= 0; i--) {
            int k = A[i] - 'a';
            len[i] = len[i + 1];
            if (crtFreq[k]) {
                crtFreq[k]--; crtLetters--;
                if (crtLetters == 0) {
                    len[i]++; crtFreq = freq; crtLetters = B.size();
                }
            }
        }

        // find the min lexicographically solution
        for (int cnt = len[0], start = 0, end; cnt; cnt--) {
            // find the range for the current anagram -- [p, q)
            for (end = start; end < A.size() && len[end] >= cnt - 1; end++);
            if (end < A.size()) end--;

            // compute the frequencies for the [p, q) range
            vector<int> rangeFreq(26);
            for (int i = start; i < end; i++) rangeFreq[A[i] - 'a']++;

            // start constructing the anagram
            // we are interested in finding the min anagram, and from these the left most one
            auto    crtFreq     = freq;
            auto    crtLetters  = B.size();
            string  anagram     = "";
            int     lastUsed    = -1;
            for (int i = start; i < end; i++) {
                // check if we can make use of this letter
                if (!crtFreq[A[i] - 'a']) {
                    rangeFreq[A[i] - 'a']--; continue;
                }

                // as long as we can improve our anagram and we still have enough
                 // letters to get the full anagram in the end, keep improve it
                while (anagram.size() && A[i] < *anagram.rbegin() &&
                       crtFreq[*anagram.rbegin() - 'a'] + 1 <= rangeFreq[*anagram.rbegin() - 'a'])
                {
                    // throw away the letter and mark it as desired for the future
                    crtFreq[*anagram.rbegin() - 'a']++; crtLetters++;
                    anagram.pop_back();
                }

                // add the current letter and remove one occurence from the frequency tables
                anagram.push_back(A[i]);
                crtFreq[A[i] - 'a']--; crtLetters--; lastUsed = i;
                rangeFreq[A[i] - 'a']--;
            }

            // append the anagram to the solution
            ans.append(anagram);

            // set the beginning of the next sequence
            start = lastUsed + 1;
        }

        if(P==2) g << ans << "\n";
        else g << (int)ans.size() / (int)B.size() << "\n";

        return 0;
    }
}cos2;
int main(){
    cos2.solve();
    return 0;
}
