#include <iostream>

#include <fstream>
#include <cstring>
#define INFILE "multimi.in"
#define OUFILE "multimi.out"
#define NMAX  1001
#define EMAX 16017

using namespace std;

typedef struct Multime
{
    int A[EMAX];
    int card;
};


int N;                                          //numarul multimilor
Multime M[28];                                  //memoreaza multimile date
int card[28];                                   //cardinalul fiecarei multimi
char *oper  = new char[1001];                  //memoreaza sirul de operatii
Multime st[505];
bool pr[505]={false};
char op[505]={' '};

ofstream out(OUFILE);


int strTOint(char *s)                           //transforma un sir intr-un numar intreg
{
    int rez = 0, i;
    for(i=0; i<strlen(s); ++i)
        rez = rez * 10 + s[i] - 48;
    return rez;
}

void strTOset(char *s, int v[], int &nv)       //transforma multimea din forma restransa (sir) in tablou de intregi
{
    char *p1, *p2, *p3, aux[100];
    int val1, val2, pas;
    p1 = strchr(s,'=');
    p2 = strchr(s,'-');
    p3 = strchr(s,'/');
    strncpy (aux, p1+1, p2-p1-1); aux[p2-p1-1] = '\0';
    val1 = strTOint(aux);
    strncpy (aux, p2+1, p3-p2-1); aux[p3-p2-1] = '\0';
    val2 = strTOint(aux);
    pas = strTOint(p3+1);
    for(nv=0 ; val1<=val2; val1 += pas)
        v[++nv] = val1;
}

void BS(int v[], int nv, int x, int &st, int &dr)
//determina indicii elementelor din v intre care se afla x
//daca st == dr atunci x se afla in tabloul v
{
    int mij;
    st = 1; dr = nv;
    while( st <= dr)
    {
        mij = (st + dr)/2;
        if(v[mij] == x)
        {
            st = dr = mij;
            break;
        }
        else
            if(x < v[mij])
                dr = mij - 1;
            else
                st = mij + 1;
    }
    mij = st, st = dr, dr = mij;
}

void MergeSets(int v1[], int &nv1, int v2[], int nv2 )
//interclaseaza elementele din v1 si ve si pune rezultatul in v1
{
    int i, j, k, v3[EMAX], nv3;
    nv3 = 0;
    i = j = 1;
    while( i <= nv1 && j <= nv2 )
        if(v1[i] < v2[j])
            v3[++nv3] = v1[i++];
        else
            if(v1[i] > v2[j])
                v3[++nv3] = v2[j++];
            else
                v3[++nv3] = v2[j], i++, j++;
    while( i <= nv1 ) v3[++nv3] = v1[i++];
    while( j <= nv2 ) v3[++nv3] = v2[j++];
    for( i=1; i<=nv3; ++i) v1[i] = v3[i];
    nv1 = nv3;
}

void InterSets(int v1[], int &nv1, int v2[], int nv2)
//intersecteaza doua multimi si pune rezultatul in prima
{
    int i, j, k, st, dr;
    int v3[EMAX], nv3;
    nv3 = 0;
    if(nv1 < nv2)
        for(i = 1; i<=nv1; i++)
        {
            BS(v2, nv2, v1[i], st, dr);
            if(st == dr)
                v3[++nv3] = v1[i];
        }
    else
        for(i = 1; i<=nv2; i++)
        {
            BS(v1, nv1, v2[i], st, dr);
            if(st == dr)
                v3[++nv3] = v2[i];
        }
    for(i = 1; i<=nv3; i++)
        v1[i] = v3[i];
    nv1 = nv3;
}

void print(int v[], int nv)                     //tipareste un tablou de intregi
{
    int i;

    out<<nv<<'\n';
    for(i=1; i<=nv; i++)
        out<<v[i]<<' ';
    out<<'\n';

}


int main()
{
    cout<<"start"<<endl;
    int i, lg, vf;
    char *sir = new char[100];
    ifstream IN(INFILE);
    IN>>N;
    IN.get();
    for(i=1; i<=N; i++)
    {
        IN.get(sir, 100);
        IN.get();
        strTOset(sir, M[sir[0]-65].A, M[sir[0]-65].card);
    }
    IN.get(oper, 1001);
    IN.get();
    IN.close();


    //rezolvare
    vf = 0;
    lg = strlen(oper);
    for(i=0; i<lg; i++)
    {
        if('A' <= oper[i] && oper[i] <= 'Z')
        {
            st[++vf] = M[oper[i]-65];
            if(oper[i+1] == '+' || oper[i+1] == '*')
                op[vf] = oper[i+1];
        }
        if(oper[i] == '+' || oper[i] == '*')
            op[vf] = oper[i];
        if(oper[i] == '(')
            pr[vf+1] = true;
        if(oper[i] == ')' )     //efectuez toate operatiile pana la paranteza deschisa
        {
            while(vf>1 && ! pr[vf])
                if(op[vf-1] == '*') { InterSets(st[vf-1].A, st[vf-1].card, st[vf].A, st[vf].card); vf--; op[vf]=' ';} else
                if(op[vf-1] == '+') { MergeSets(st[vf-1].A, st[vf-1].card, st[vf].A, st[vf].card); vf--; op[vf]=' ';}
            if( pr[vf] )
            {
                pr[vf] = false;
                op[vf] =' ';
            }
        }

        //fac operatiile din varful stivei, daca se poate
        if(vf>1 && ! pr[vf] )  //nu am paranteaza inaintea multimii din varful stivei
        {
            if(op[vf-1] == '*') { InterSets(st[vf-1].A, st[vf-1].card, st[vf].A, st[vf].card); vf--; op[vf]=' ';} else
            if(op[vf-1] == '+' && oper[i+1] == '+') { MergeSets(st[vf-1].A, st[vf-1].card, st[vf].A, st[vf].card); vf--; op[vf]=' ';}
        }

    }
    while(vf>1 && ! pr[vf] )  //nu am paranteaza inaintea multimii din varful stivei
        {
            if(op[vf-1] == '*') { InterSets(st[vf-1].A, st[vf-1].card, st[vf].A, st[vf].card); vf--; op[vf]=' ';} else
            if(op[vf-1] == '+') { MergeSets(st[vf-1].A, st[vf-1].card, st[vf].A, st[vf].card); vf--; op[vf]=' ';}
        }


    print(st[1].A, st[1].card);

    out.close();
    return 0;
}
