#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

int abs(int x) {
    if (x < 0)
        return -x;
    return x;
}

static const int dx[4] = {-1, 0, 1, 0};
static const int dy[4] = {0, -1, 0, 1};

bool back(const vector< vector<int> > &V, int x, int y, const vector<int>& values, int K, vector< pair<int, int> > &where) {
    if (x < 0 || y < 0 || x >= int(V.size()) || y >= int(V[x].size()))
        return false;

    if (V[x][y] != values[K])
        return false;

    where.emplace_back(x, y);
    K += 1;
    if (K == int(values.size()))
        return true;

    for (int i = 0; i < 4; ++i) {
        int new_x = x + dx[i];
        int new_y = y + dy[i];
        if (back(V, new_x, new_y, values, K, where))
            return true;
    }
    where.pop_back();
    return false;
}

vector< pair<int, int> > search(const vector< vector<int> > &V, vector<int> values) {
    vector< pair<int, int> > where;
    for (int i = 0; i < int(V.size()); ++i)
        for (int j = 0; j < int(V.size()); ++j)
            if (back(V, i, j, values, 0, where))
                return where;
    return where;
}

int main() {
    ifstream cin("siruri.in");
    ofstream cout("siruri.out");

    int N, K; assert(cin >> N >> K);
    assert(1 <= N && N <= 100);
    assert(1 <= K && K <= 100 * 1000);

    vector< vector<int> > M(N, vector<int>(N));
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < N; ++j) {
            assert(cin >> M[i][j]);
            assert(0 <= M[i][j] && M[i][j] <= 1);
        }

    vector<int> S(K);
    for (int i = 0; i < K; ++i) {
        assert(cin >> S[i]);
        assert(0 <= S[i] && S[i] <= 1);
    }

    if (K == 1) { // simple case
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < N; ++j)
                if (S[0] == M[i][j]) {
                    cout << i + 1 << " " << j + 1 << "\n";
                    return 0;
                }
        cout << "-1\n";
        return 0;
    }

    int zeros = count(S.begin(), S.end(), 0);
    int ones = count(S.begin(), S.end(), 1);

    if (zeros == 0 || ones == 0 || abs(zeros - ones) <= 1) {
        vector< pair<int, int> > how;
        if (zeros == 0)
            how = search(M, {1, 1});
        else if (ones == 0)
            how = search(M, {0, 0});
        else if (zeros > ones)
            how = search(M, {0, 1});
        else
            how = search(M, {1, 0});

        if (how.empty()) {
            cout << "-1\n";
            return 0;
        }

        for (int i = 0; i < K; ++i)
            cout << how[i % 2].first + 1 << " " << how[i % 2].second + 1 << "\n";
        return 0;
    }

    vector< pair<int, int> > how;
    int first_part;
    if (zeros > ones) {
        how = search(M, {0, 0, 1});
        first_part = zeros;
    } else {
        how = search(M, {1, 1, 0});
        first_part = ones;
    }

    if (how.empty()) {
        cout << "-1\n";
        return 0;
    }

    int second_part = K - first_part;
    for (int i = 0; i < second_part; ++i) {
        cout << how[2].first + 1 << " " << how[2].second + 1 << "\n";
        cout << how[1].first + 1 << " " << how[1].second + 1 << "\n";
    }

    for (int i = 0; i < first_part - second_part; ++i) {
        cout << how[i % 2].first + 1 << " " << how[i % 2].second + 1 << "\n";
    }
}
